SystemOrganization addCategory: #MyFirstWebApp!

TestCase subclass: #MyFirstWebAppTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyFirstWebApp'!

!MyFirstWebAppTests methodsFor: 'as yet unclassified' stamp: 'GermanArduino 4/8/2015 14:09'!
image
  ^ ZnClient new
      beOneShot;
      get: 'http://zn.stfx.eu/zn/Hot-Air-Balloon.gif';
      entity! !

!MyFirstWebAppTests methodsFor: 'as yet unclassified' stamp: 'GermanArduino 4/8/2015 14:06'!
testDefaultImage
  self withServerDo: [ :server |
    | client |
    client := ZnClient new.
    client url: server localUrl; addPath: #image; queryAt: #raw put: #true.
    client get.
    self assert: client isSuccess.
    self assert: (client entity contentType matches: 'image/*' asZnMimeType).
    self assert: client entity equals: server delegate image.
    client close ]! !

!MyFirstWebAppTests methodsFor: 'as yet unclassified' stamp: 'GermanArduino 4/8/2015 14:03'!
testMainPage
  self withServerDo: [ :server |
    | client |
    client := ZnClient new.
    client url: server localUrl; addPath: #image.
    client get.
    self assert: client isSuccess.
    self assert: (client entity contentType matches: ZnMimeType textHtml).
    self assert: (client contents includesSubstring: 'Image').
    client close ]! !

!MyFirstWebAppTests methodsFor: 'as yet unclassified' stamp: 'GermanArduino 4/8/2015 14:09'!
testUpload
  self withServerDo: [ :server |
    | image client |
    image := self image.
    client := ZnClient new.
    client url: server localUrl; addPath: #image.
    client addPart: (ZnMimePart fieldName: #file entity: image).
    client post.
    self assert: client isSuccess.
    client resetEntity; queryAt: #raw put: #true.
    client get.
    self assert: client isSuccess.
    self assert: client entity equals: image.
    client close ]! !

!MyFirstWebAppTests methodsFor: 'as yet unclassified' stamp: 'GermanArduino 4/8/2015 14:02'!
withServerDo: block
  | server |
  server := ZnServer on: 1700 + 10 atRandom.
  [ 
    server start.
    self assert: server isRunning & server isListening.
    server delegate: MyFirstWebApp new.
    block cull: server
  ] 
    ensure: [ server stop ]! !

Object subclass: #MyFirstWebApp
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyFirstWebApp'!

!MyFirstWebApp commentStamp: 'GermanArduino 4/7/2015 14:36' prior: 0!
TBD.

Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!MyFirstWebApp methodsFor: 'public' stamp: 'GermanArduino 4/7/2015 14:45'!
downloadPharoLogo
  ^ ZnClient new 
      beOneShot;
      get: 'http://pharo.org/web/files/pharo.png';
      entity! !

!MyFirstWebApp methodsFor: 'public' stamp: 'GermanArduino 4/8/2015 14:04'!
handleGetRequest: request
  ^ (request uri queryAt: #raw ifAbsent: [ nil ])
      ifNil: [ ZnResponse ok: (ZnEntity html: self html) ]
      ifNotNil: [ ZnResponse ok: self image ]! !

!MyFirstWebApp methodsFor: 'public' stamp: 'GermanArduino 4/8/2015 13:59'!
handlePostRequest: request
  | part newImage badRequest |
  badRequest := [ ^ ZnResponse badRequest: request ].
  (request hasEntity 
      and: [ request contentType matches: ZnMimeType multiPartFormData ])
    ifFalse: badRequest.
  part := request entity 
            partNamed: #file
            ifNone: badRequest.
  newImage := part entity.
  (newImage notNil 
      and: [ newImage contentType matches: 'image/*' asZnMimeType ])
    ifFalse: badRequest.
  [ self formForImageEntity: newImage ]
    on: Error 
    do: badRequest.
  image := newImage.
  ^ ZnResponse redirect: #image! !

!MyFirstWebApp methodsFor: 'public' stamp: 'GermanArduino 4/7/2015 14:51'!
handleRequest: request
  request uri path = #image
    ifTrue: [ 
      request method = #GET
        ifTrue: [ ^ self handleGetRequest: request ].
      request method = #POST
        ifTrue: [ ^ self handlePostRequest: request ] ].
  ^ ZnResponse notFound: request uri! !

!MyFirstWebApp methodsFor: 'public' stamp: 'GermanArduino 4/7/2015 14:48'!
html
  ^ '<html><head><title>Image</title>
  <body>
  <h1>Image</h1>
  <img src="image?raw=true"/>
  <br/>
  <form enctype="multipart/form-data" action="image" method="POST">
   <h3>Change the image:</h3>
   <input type="file" name="file"/>
   <input type="submit" value= "Upload"/>
  </form>
  </body></html>'! !

!MyFirstWebApp methodsFor: 'public' stamp: 'GermanArduino 4/7/2015 14:38'!
image
  ^ image ifNil: [ image := self downloadPharoLogo ]! !

!MyFirstWebApp methodsFor: 'public' stamp: 'GermanArduino 4/7/2015 14:22'!
value: request
  ^ self handleRequest: request! !
